package com.logicbig.example;

import com.logicbig.example.api.ItemRestService;
import org.glassfish.jersey.server.ResourceConfig;
import org.glassfish.jersey.test.JerseyTest;
import org.junit.Test;

import javax.ws.rs.HeaderParam;
import javax.ws.rs.client.Entity;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.Application;
import javax.ws.rs.core.GenericType;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import java.math.BigDecimal;
import java.util.List;

public class ItemRestServiceTest extends JerseyTest {
    @Override
    protected Application configure() {
        return new ResourceConfig(ItemRestService.class);
    }

    @Test
    public void customerRestServiceFormTest() throws Exception {

        Item item = new Item();
        item.setName("Internal HDD");
        item.setPrice(new BigDecimal(50));

        WebTarget target = target("items");
        //put new resource at /items/10
        Response response = target.path("10").request()
                  .put(Entity.entity(item, MediaType.APPLICATION_JSON));
        System.out.println(response.getHeaderString("Location"));
        System.out.println(response.getStatus());

        //put one more item at /items/20
        item = new Item();
        item.setName("Varion Laptop");
        item.setPrice(new BigDecimal(450));
        response = target.path("20").request(MediaType.APPLICATION_JSON)
                  .put(Entity.entity(item, MediaType.APPLICATION_JSON));
        System.out.println(response.getHeaderString("Location"));
        System.out.println(response.getStatus());

        // try to put the same resource will generate 204 status code
        response = target.path("20").request(MediaType.APPLICATION_JSON)
                  .put(Entity.entity(item, MediaType.APPLICATION_JSON));
        System.out.println(response.getHeaderString("Location"));
        System.out.println(response.getStatus());


        //get all items at resource /items
        List<Item> items = target.request(MediaType.APPLICATION_JSON)
                  .get(new GenericType<List<Item>>() {
                  });
        //note in above line we used GenericType
        // cause readEntity(class) cannot handle the generics
        System.out.println("all items: "+items);


    }
}